/***************************************************************************
                          Bomber.h  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Bomber.h,v 1.15 1999/05/14 15:18:19 dk Exp $

#ifndef Bomber_h
#define Bomber_h

#include "GameObject.h"
#include "Controller.h"


class Bomber : public GameObject
{
public:
	typedef enum
	{
		RED		= 0,
		BLUE		= 1,
		YELLOW	= 2,
		GREEN	= 3,
	} COLOR;

	Bomber( int _x, int _y, COLOR _color, Controller* _controller, CL_String _name, ClanBomberApplication *_app);
	~Bomber();
	
	void dec_points();
	void inc_points();
	void set_points( int _points );
	int get_points();
	bool is_dead();
	int get_deaths();
	int get_kills();
	void inc_kills();
	int get_cur_bombs();

	COLOR get_color();

	void gain_extra_bomb();
	void gain_extra_skateboard();
	void gain_extra_kick();
	void gain_extra_glove();
	void gain_extra_power();
	void loose_all_extras();

	void inc_cur_bombs();
	void dec_cur_bombs();

	void put_bomb();

	bool die();
	
	void show();
	void show( int _x, int _y );
	void show_won();
	void act();
	
	CL_String get_name();
	
	ObjectType get_type()
	{
		return BOMBER;
	}
	void init();
	
protected:
	COLOR color;
	CL_String name;
	Controller* controller;
	int deaths;
	int kills;
	bool dead;
	float anim_count;
	int points;
	bool can_throw;

	int skateboards;
	int cur_bombs;
	int bombs;
	int power;
	int gloves;

	int extra_gloves;
	int extra_skateboards;
	int extra_power;
	int extra_kick;
	int extra_bombs;
	
	bool bomb_key;
};

#endif



















