/***************************************************************************
                          Bomber_Corpse.cpp  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Bomber_Corpse.cpp,v 1.8 1999/05/15 10:46:03 dk Exp $

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "ClanBomber.h"
#include "Bomber_Corpse.h"

Bomber_Corpse::Bomber_Corpse ( int _x, int _y, int _color, int _sprite_nr, ClanBomberApplication *_app ) : GameObject(_x, _y, _app )
{
	sprite_nr = _sprite_nr;
	color = _color;
	ready_to_splash = true;
	splash_counter=0;
	app->objects.add( this );
	z = Z_CORPSE + y;
}

void Bomber_Corpse::act()
{
	if (falling)
	{
		continue_falling();
		if (fallen_down)
		{
			delete_me = true;
			return;
		}
	}
	
	if (splash_counter!=-1)
	{
		CL_Iterator<Bomber> bomber_object_counter(app->bomber_objects);
		while (bomber_object_counter.next() != NULL)
		{
			if (!bomber_object_counter()->is_dead())
			{
				if (abs(bomber_object_counter()->get_x() - x) < 30)
				{
					if (abs(bomber_object_counter()->get_y() - y) < 30)
					{
//						bomber_object_counter()->move(100);
						if (ready_to_splash)
						{
							app->sfx_splash[rand()%12]->play();
							splash_counter++;
							if (splash_counter==5)
							{
								splash_counter=-1;					
							}
					
						}
						ready_to_splash=false;
						return;
					}				
				}
			}
		}
	}
	ready_to_splash = true;
}

void Bomber_Corpse::show()
{

	if (splash_counter==-1)
	{
		if (falling)
		{
			app->sur_bomber[color]->put_screen( x+80-fall_countdown*20, y+50-fall_countdown*30, fall_countdown, fall_countdown, sprite_nr );
		}
		else
		{
			app->sur_bomber[color]->put_screen( x+60, y+20, sprite_nr );
		}
	}
	else
	{
		if (falling)
		{
			app->sur_bomber[color]->put_screen( x+80-fall_countdown*20+(rand()%2), y+50-fall_countdown*30+(rand()%2), fall_countdown, fall_countdown, sprite_nr );
		}
		else
		{
			app->sur_bomber[color]->put_screen( x+60+(rand()%2), y+20+(rand()%2), sprite_nr );
		}
	}
}

Bomber_Corpse::~Bomber_Corpse()
{
}












