/***************************************************************************
                          ClanBomber.h  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: ClanBomber.h,v 1.27 1999/05/15 15:56:45 dk Exp $

#ifndef ClanBomber_h
#define ClanBomber_h

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "GameObject.h"
#include "Bomber.h"
#include "Bomb.h"
#include "Map.h"
#include "Observer.h"

class Menu;
class Debug;

#define MENU_LOCALGAME		1
#define MENU_NETWORKGAME		2
#define MENU_OPTIONS		3
#define MENU_CREDITS		4
#define MENU_PLAYER_SETUP	5
#define MENU_EXTRAS			6
#define MENU_EXIT			7
#define MENU_CONTROLLER		8
#define MENU_HELP			9

#define CONFIG_BOMBS		31
#define CONFIG_POWER		32
#define CONFIG_SKATES		33
#define CONFIG_KICK			34
#define CONFIG_MAX_BOMBS		35
#define CONFIG_MAX_POWER		36
#define CONFIG_MAX_SKATES	37
#define CONFIG_PLAYERS		38
#define CONFIG_AI			39
#define CONFIG_PLAYER1_NAME	40
#define CONFIG_PLAYER2_NAME	41
#define CONFIG_PLAYER3_NAME	42
#define CONFIG_PLAYER4_NAME	43
#define CONFIG_POINTS		44
#define CONFIG_THEME		45
#define CONFIG_GLOVE		46
#define CONFIG_ROTATE_LEVELS	47
#define CONFIG_STARTLEVEL	48
#define CONFIG_ROUND_TIME	49

#define CONFIG_CONTROLLER1	61
#define CONFIG_CONTROLLER2	62
#define CONFIG_CONTROLLER3	63
#define CONFIG_CONTROLLER4	64

#define LOCALGAME_START		51

class ClanBomberApplication : public CL_ClanApplication
{
friend Debug;
protected:

	void load_resources();
	void run_intro();
	void init_game();
	void deinit_game();
	void show_credits();
	void show_tutorial();

	void run_game();
	void show_all();
	void act_all();
	
	Menu* menu;
	
	Observer* observer;
	CL_SoundBuffer* wav;
	CL_SoundBuffer_Session ses;

public:
	CL_Font *fnt_clansoft;
	CL_Font *fnt_smallfont;

	CL_Surface *sur_fl_logo;
	CL_Surface *sur_maptiles;
	CL_Surface *sur_extras;
	CL_Surface *sur_bomber[8];
	CL_Surface *sur_observer;
	CL_Surface *sur_bomb;
	CL_Surface *sur_explode;
	CL_Surface *sur_ps_controls;
	CL_Surface *sur_ps_teams;


	CL_ResourceManager *res_app;
	CL_ResourceManager *res_game;
     CL_SoundBuffer *sfx_typewriter;
	CL_SoundBuffer *sfx_furz;
	CL_SoundBuffer *sfx_wow;
	CL_SoundBuffer *sfx_explode;
	CL_SoundBuffer *sfx_putbomb;
	CL_SoundBuffer *sfx_die;
	CL_SoundBuffer *sfx_hurryup;
	CL_SoundBuffer *sfx_splash[12];

	Map* map;
	CL_List<GameObject> objects;
	CL_List<Bomber> bomber_objects;
	virtual char *get_title();
	virtual int main(int argc, char** argv);
};

#endif
