/***************************************************************************
                          Config.h  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Config.h,v 1.11 1999/05/15 15:56:45 dk Exp $

#ifndef Config_h
#define Config_h

#include "Bomber.h"

class BomberConfig
{
public:
	BomberConfig();
	~BomberConfig();
	
	int		get_skin();
	CL_String	get_name();
	int		get_team();
	int		get_controller();
	
	void	set_skin(int _skin);
	void	set_name(CL_String _name);
	void	set_team(int _team);
	void	set_controller(int _controller);
	
	void	enable();
	void disable();
	bool is_enabled();
	void set_enabled(bool _enabled);

protected:
	bool		enabled;
	int		skin;
	CL_String	name;
	int		team;
	int		controller;
};

class Config
{
public:
	static void set_round_time(int);

     static void set_max_skateboards(int);
     static void set_max_power(int);
     static void set_max_bombs(int);
	
	static void set_start_skateboards(int);
     static void set_start_power(int);
     static void set_start_bombs(int);
	static void set_start_kick(bool);
	static void set_start_glove(bool);
	
	static void set_start_level(int);
	static void set_rotate_levels(bool);
	
	static void set_points_to_win(int);
	static void set_theme(int);
	
	static void set_filename(CL_String _filename);

	static int get_round_time();
	
	static int get_max_skateboards();
     static int get_max_power();
     static int get_max_bombs();

	static int get_start_skateboards();
     static int get_start_power();
     static int get_start_bombs();
	static bool get_start_kick();
	static bool get_start_glove();
	
	static int get_start_level();
	static bool get_rotate_levels();
	
	static int get_points_to_win();
	static int get_theme();

	
	static bool load();
	static bool save();

	static BomberConfig bomber[8];

protected:
	static int round_time;
	
	static int max_skateboards;
	static int max_power;
	static int max_bombs;
	
	static int start_bombs;
	static int start_power;
	static int start_skateboards;
	static bool start_kick;
	static bool start_glove;
	
	static int start_level;
	static bool rotate_levels;
	
	static int points_to_win;
	static int theme;
	
	static CL_String filename;
};

#endif


















