/***************************************************************************
                          Debug.cpp  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Debug.cpp,v 1.12 1999/05/15 15:56:45 dk Exp $

#define NR_LEVELS 5

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "Debug.h"
#include "ClanBomber.h"
#include "Timer.h"
#include "Config.h"
#include "Controller.h"


Debug::Debug( int _x, int _y, ClanBomberApplication *_app ) : GameObject( _x, _y, _app )
{
	app->objects.add( this );
	current_level=1;
	frame_count = 0;
	frame_time = 0;
	fps = 0;
	show_fps = true;
	key_F1 = false;
	key_F5 = false;
	key_divide = false;
	key_multiply = false;
}

Debug::~Debug()
{
}

void Debug::show()
{
	CL_Display::fill_rect( 360,3, 440,38, 0,0,0,1 );
	if (show_fps)
	{
		app->fnt_clansoft->print_center(400,3,CL_String(fps) + " fps");
	}
}

void Debug::act()
{
	frame_count++;
	frame_time += Timer::time_elapsed();
	if (frame_time > 2)
	{
		fps = (int)(frame_count/frame_time);
		frame_time = 0;
		frame_count = 0;
	}
	
	if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_KP_MULT) && !key_multiply)
	{
		current_level++;
		if (current_level > NR_LEVELS)
		{
			current_level=NR_LEVELS;
		}
		app->map->load(CL_String("Levels/level")+current_level);
	}
	key_multiply = CL_Keyboard::get_keycode(CL_Keyboard::KEY_KP_MULT);
	
	if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_KP_DIV) && !key_divide)
	{
		current_level--;
		if (current_level < 1)
		{
			current_level=1;
		}
		app->map->load(CL_String("Levels/level")+current_level);
	}
	key_divide = CL_Keyboard::get_keycode(CL_Keyboard::KEY_KP_DIV);

	
	if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_F1) && !key_F1)
	{
		show_fps = (show_fps == false);
	}
	key_F1 = CL_Keyboard::get_keycode(CL_Keyboard::KEY_F1);

	
	if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_F2))
	{
		new Bomber(((rand()%(MAP_WIDTH-2))+1)*40,((rand()%(MAP_HEIGHT-2))+1)*40,Bomber::GREEN, Controller::create(Controller::AI), "Debug Robi", app);
	}
	
	if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_F3))
	{
	
	}
}

















