/***************************************************************************
                          Extra.cpp  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Extra.cpp,v 1.15 1999/04/10 14:52:06 andi Exp $

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "Extra.h"
#include "ClanBomber.h"
#include "MapField.h"
#include "Timer.h"


Extra::Extra( int _x, int _y, ClanBomberApplication *_app ) : GameObject( _x, _y, _app )
{
  app->objects.add( this );
  destroyed = false;
  z = Z_EXTRA;
}

Extra::Extra( ClanBomberApplication *_app, int _x, int _y ) : GameObject( _x, _y , _app )
{
  int xmapfield = rand() % 17;
  int ymapfield = rand() % 13;
  while (app->map->mapfield[xmapfield][ymapfield]->type!=MapField::GROUND)
  {
	xmapfield = rand() % 17;
	ymapfield = rand() % 13;
  }
  app->objects.add( this );
  destroyed = false;
  z = Z_EXTRA;
//  set_pos(xmapfield*40,ymapfield*40);
  fly_to(xmapfield*40 ,ymapfield*40);
}

Extra::~Extra()
{
}

void Extra::act()
{
	GameObject::act();
	if (falling)
	{
		return;
	}
	if (fallen_down)
	{
		delete_me = true;
		return;
	}
	
	if (destroyed)
	{
		destroy_countdown -= Timer::time_elapsed();
		if (destroy_countdown <= 0)
		{
			delete_me = true;
			return;
		}
	}

	if (!flying)
	{
		CL_Iterator<Bomber> bomber_object_counter(app->bomber_objects);
		while (bomber_object_counter.next() != NULL)
		{
			if (!(bomber_object_counter()->is_dead()))
			{
				int bx = (bomber_object_counter()->get_x()+20)/40;
				int by = (bomber_object_counter()->get_y()+20)/40;
				
				if (bx==x/40 && by==y/40)
				{
					app->sfx_wow->play();			
					effect( bomber_object_counter() );
					delete_me = true;
					break;
				}
			}
		}
	}
}

void Extra::destroy()
{
	if (!destroyed)
	{
		destroyed = true;
		destroy_countdown = 0.2f;
	}
}

void Extra::show()
{
	if (falling)
	{
		app->sur_extras->put_screen( x+80-fall_countdown*20, y+60-fall_countdown*20, fall_countdown, fall_countdown, sprite_nr );
	}
	else if (flying)
	{
		float scalefactor = sinf(((start_fly_power - fly_power) / start_fly_power)*3.14f) * (start_fly_power/200)+1;
		app->sur_extras->put_screen( x+80-scalefactor*20, y+80-scalefactor*40, scalefactor, scalefactor, sprite_nr );
	}
	else
	{
		app->sur_extras->put_screen( x+60, y+40, sprite_nr );
	}
	
}










































