/***************************************************************************
                          GameStatus.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Mar 19 1999                                           
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp                         
    email                : clanbomber@fischlustig.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
// $Id: GameStatus.cpp,v 1.17 1999/04/10 22:46:35 dk Exp $

#include <ClanLib/clanlib.h>
#include "ClanBomber.h"
#include "GameStatus.h"
#include "GameObject.h"
#include "Config.h"
#include "Timer.h"

GameStatus::GameStatus(ClanBomberApplication* _app)
{
	app = _app;
	sur_game_status = CL_Res_Surface::load("Game/sur_game_status", *(app->res_game));
	sur_gs_tools = CL_Res_Surface::load("Game/sur_gs_tools", *(app->res_game));
}

void GameStatus::show()
{
	float pokal_scroll_in = 800;

	Timer timer;
	timer.reset();
	
	while(!(CL_Keyboard::get_keycode(CL_Keyboard::KEY_SPACE)))
	{
		sur_game_status->put_screen(0, 0, 0 );
		
		if (!winner)
		{
			app->fnt_clansoft->print_center( 500, 40, "Draw Game" );
		}
		else
		{
			app->fnt_clansoft->print_center( 500, 40, winner->get_name() + " won" );
		}
		
		
		int nr = 0;
		CL_Iterator<Bomber> bomber_object_counter(app->bomber_objects);
		while ((bomber_object_counter.next() != NULL) && (nr < 8))
		{
			nr++;
			bomber_object_counter()->act();
			bomber_object_counter()->show( 5+(nr%2)*20, 130+nr*43);
			app->fnt_clansoft->print_left( 70, 157+nr*43,bomber_object_counter()->get_name() );
			
			if (bomber_object_counter() == winner)
			{
				for (int i=0; i<bomber_object_counter()->get_points()-1; i++)
				{
					sur_gs_tools->put_screen(300+i*43, 150+nr*43, 0 );
				}
				sur_gs_tools->put_screen( max(257+bomber_object_counter()->get_points()*43, (int)pokal_scroll_in), 150+nr*43, 0 );
			}
			else
			{
				for (int i=0; i<bomber_object_counter()->get_points(); i++)
				{
					sur_gs_tools->put_screen(300+i*43, 150+nr*43, 0 );
				}
			}
		}
		if (end_of_game)
		{
			app->fnt_clansoft->print_left( 400, 300, winner->get_name() + " won the Match");
			winner->show_won();
		}

		CL_Display::flip_display();
		if (pokal_scroll_in > 100)
		{
			pokal_scroll_in -= timer.time_elapsed(true)*1000.0f;
		}
		CL_System::keep_alive();
	}
	CL_Display::clear_display();
	CL_Display::flip_display();
	CL_Display::clear_display();
	CL_Display::flip_display();
}

GameStatus::~GameStatus()
{
}

void GameStatus::analyze_game()
{
	end_of_game = false;
	winner = NULL;
	
	CL_Iterator<Bomber> bomber_object_counter(app->bomber_objects);
	while (bomber_object_counter.next() != NULL)
	{
		if (!bomber_object_counter()->is_dead())
		{
			winner = bomber_object_counter();
		}
		if (bomber_object_counter()->get_points() == Config::get_points_to_win() )
		{
			end_of_game = true;
		}
	}
}

bool GameStatus::get_end_of_game()
{
	return end_of_game;
}
























