/***************************************************************************
                          Map.h  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: Map.h,v 1.7 1999/04/13 22:54:14 dk Exp $

#ifndef Map_h
#define Map_h

#include "GameObject.h"
#include "MapField.h"
#include "Bomb.h"

#define MAP_WIDTH	17
#define MAP_HEIGHT	13
#define MAP_COUNT	8

class ClanBomberApplication;

class Map
{
public:
	Map( ClanBomberApplication* _app );
	~Map();

	bool add_bomb( int bx, int by, int bpower, Bomber *bomber );
	void clear();
	void load( CL_String name );
	void show();
	void refresh_holes();
	void act();
	void shake( int _shake );
	
	CL_Vector get_bomber_pos(int nr);
	
	MapField* mapfield[MAP_WIDTH][MAP_HEIGHT];

protected:
	ClanBomberApplication* app;
	CL_Vector bomber_pos[8];
	int is_shaken;
};

#endif








