/***************************************************************************
                          MapField.h  -  description
                             -------------------
    begin                : ?
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp
    email                : clanbomber@fischlustig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: MapField.h,v 1.8 1999/05/14 14:00:12 andi Exp $

#ifndef MapField_h
#define MapField_h

#include "Bomb.h"

class MapField
{
public:	 
 	void destroy();
	enum
	{
		NONE      = -1,
		GROUND	= 0,	// normal field
		WALL		= 1,	// indestructable wall
		D_WALL	= 2,	// destructable wall
		L_WALL	= 3,	// labil wall (being destroyed)

	};

	int type;
	int theme;
	MapField( int _x, int _y,int _type, int _theme, ClanBomberApplication *_app);
	~MapField();
	Bomb* bomb;

	void act();
	void show();
	void show_shaken();
	
	void vanish();

protected:
	ClanBomberApplication *app;
	int	x;
	int  y;
	float vanish_countdown;
	bool vanishing;
	bool destroyed;
	float destroy_countdown;
	void spawn_extra();
	int rating;
};

#endif












