/***************************************************************************
                          Observer_Classic.h  -  description                              
                             -------------------                                         
    begin                : Fri May 14 1999                                           
    copyright            : (C) 1999 by Andreas Hundt, Denis Oliver Kropp                         
    email                : clanbomber@fischlustig.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef OBSERVER_CLASSIC_H
#define OBSERVER_CLASSIC_H

#include "Observer.h"

/**
  *@author Andreas Hundt, Denis Oliver Kropp
  */

class Observer_Classic : public Observer
{
public: 
	Observer_Classic( int _x, int _y, ClanBomberApplication *_app );
	~Observer_Classic();
	
	void show();
	void act();
	
	typedef enum
	{
		NORMAL,
		END_ROUND
	} Mode;
	
protected:
	Mode	mode;
	GameStatus* game_status;
	CL_List<Bomber> corpse_container;
	int rounds;
	float round_time;
	float destroy_countdown;
	bool play_hurryup;
	
	void act_normal();
	void act_waiting_for_explosions();
	void clean_corpses();
	void revive_bombers();
	void kill_all_bombers();
	void reset_round_time();
};

#endif






